; csc -s magic.scm -L -lmagic

; Copyright (c) 2005,2006 by Peter Busser
; This file has been released under the BSD licence. See magic.html for the
; licence text.

(declare
 (export

  magic-open
  magic-load
  magic-error
  magic-file
  magic-close
  magic-setflags
  magic-errno
  magic-sanitize-mime-type

  MAGIC_NONE
  MAGIC_DEBUG
  MAGIC_SYMLINK	
  MAGIC_COMPRESS
  MAGIC_DEVICES
  MAGIC_MIME
  MAGIC_CONTINUE
  MAGIC_CHECK
  MAGIC_PRESERVE_ATIME
  MAGIC_RAW
  MAGIC_ERROR
 ))


#>
#include <magic.h>
<#

#>!
___declare(export_constants, yes)
#define	MAGIC_NONE		0x000	/* No flags */
#define	MAGIC_DEBUG		0x001	/* Turn on debugging */
#define	MAGIC_SYMLINK		0x002	/* Follow symlinks */
#define	MAGIC_COMPRESS		0x004	/* Check inside compressed files */
#define	MAGIC_DEVICES		0x008	/* Look at the contents of devices */
#define	MAGIC_MIME		0x010	/* Return a mime string */
#define	MAGIC_CONTINUE		0x020	/* Return all matches */
#define	MAGIC_CHECK		0x040	/* Print warnings to stderr */
#define	MAGIC_PRESERVE_ATIME	0x080	/* Restore access time on exit */
#define	MAGIC_RAW		0x100	/* Don't translate unprintable chars */
#define	MAGIC_ERROR		0x200	/* Handle ENOENT etc as real errors */
<#

(define-foreign-type magic-t (pointer (struct "magic_set")))

(define magic-open
  (foreign-lambda magic-t "magic_open" int))

(define magic-load
  (foreign-lambda int "magic_load" magic-t (const c-string)))

(define magic-error
  (foreign-lambda c-string "magic_error" magic-t))

(define magic-file
  (foreign-lambda c-string "magic_file" magic-t (const c-string)))

(define magic-close
  (foreign-lambda void "magic_close" magic-t))

(define magic-setflags
  (foreign-lambda int "magic_setflags" magic-t int))

(define magic-errno
  (foreign-lambda int "magic_errno" magic-t))

;
; Sanitizes the mime-type provided by magic-file (with the MAGIC_MIME and
; MAGIC_SYMLINK flags set in magic-open). The mime-types stored in the
; file database sometimes do not contain useful information in which case
; this function provides an alternative. Or it contains additional garbage,
; in which case it strips the garbage.
;
(define (magic-sanitize-mime-type raw-mime-type path)
  (if raw-mime-type
    (if (string=? raw-mime-type "")
      "unknown"
      (if (directory? path)
	"directory"
	(car (string-split raw-mime-type ";,"))))
    (if (symbolic-link? path)
      "symlink"
      "unknown")))

